HDU 2087 剪花布条(KMP 三种做法)

2023-11-10 00:38

本文主要是介绍HDU 2087 剪花布条(KMP 三种做法),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

剪花布条
Time Limit: 1000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3083    Accepted Submission(s): 2079


Problem Description
一块花布条,里面有些图案,另有一块直接可用的小饰条,里面也有一些图案。对于给定的花布条和小饰条,计算一下能从花布条中尽可能剪出几块小饰条来呢?
 

Input
输入中含有一些数据,分别是成对出现的花布条和小饰条,其布条都是用可见ASCII字符表示的,可见的ASCII字符有多少个,布条的花纹也有多少种花样。花纹条和小饰条不会超过1000个字符长。如果遇见#字符,则不再进行工作。
 

Output
输出能从花纹布中剪出的最多小饰条个数,如果一块都没有,那就老老实实输出0,每个结果之间应换行。
 

Sample Input
abcde a3

aaaaaa aa

#
Sample Output
03

 

分析:

第一种:这题我是抱着试一试的态度,但没有想到竟然过了,我们找到KMP求一个串在另一个串中的出现次数(可重叠)是好求的,普通的kmp模板,但这题子串是不可重叠的,比如,aaaaaa aa,普通模板求的为5,但这题 答案是3,但我是这样处理的min(slen/tlen,KMP_Count()),直觉告诉这是对的,想一下也是对的,但具体的证明还不好说。

第二种:真正的解法为:

当模式串T的位置j==tlen时候,说明匹配完成,个数ans++,统计可重叠的循环子串的时候,j=next[j],从这里开始匹配 ,但是,统计 不可重叠的循环子串的时候,从j=0.开始匹配

举个例子:

S :aaaaa

T:aa

 

aaaaa

aa

匹配 成功an s+ +

j=next[j]:aaaaa

                  aa

  j=0:

              aaaaa

                  aa

仔细领会

第三种:饶齐大佬的做法:

定义一个last记录上一个匹配主串的位置,匹配成功后j-i>tlen

 

一:

#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;const int N = 1000002;
int nxtt[N];
char S[N], T[N];
int slen, tlen;void getNext()
{int j, k;j = 0; k = -1;nxtt[0] = -1;while(j < tlen)if(k == -1 || T[j] == T[k]){nxtt[++j] = ++k;if (T[j] != T[k]) //优化nxtt[j] = k; } elsek = nxtt[k];}
/*
返回模式串在主串S中出现的次数
*/
int KMP_Count()
{int ans = 0;int i, j = 0;if(slen == 1 && tlen == 1){if(S[0] == T[0])return 1;elsereturn 0;}getNext();for(i = 0; i < slen; i++){while(j > 0 && S[i] != T[j])j = nxtt[j];if(S[i] == T[j])j++;if(j == tlen){ans++;j = nxtt[j];}}return ans;
}
int main()
{while(~scanf("%s",&S)){if(S[0]=='#')break;scanf("%s",&T);slen = strlen(S);tlen = strlen(T);//cout<<"模式串T在主串S中首次出现的位置是: "<<KMP_Index()<<endl;cout<<min(slen/tlen,KMP_Count())<<endl;}return 0;
}
#include<stdio.h>
#include<string.h>
#include<iostream>
using namespace std;const int N = 1000002;
int nxtt[N];
char S[N], T[N];
int slen, tlen;void getNext()
{int j, k;j = 0; k = -1;nxtt[0] = -1;while(j < tlen)if(k == -1 || T[j] == T[k]){nxtt[++j] = ++k;if (T[j] != T[k]) //优化nxtt[j] = k; } elsek = nxtt[k];}
/*
返回模式串在主串S中出现的次数
*/
int KMP_Count()
{int ans = 0;int i, j = 0;if(slen == 1 && tlen == 1){if(S[0] == T[0])return 1;elsereturn 0;}getNext();for(i = 0; i < slen; i++){while(j > 0 && S[i] != T[j])j = nxtt[j];if(S[i] == T[j])j++;if(j == tlen){j = 0;ans++;}}return ans;
}
int main()
{while(~scanf("%s",&S)){if(S[0]=='#')break;scanf("%s",&T);slen = strlen(S);tlen = strlen(T);//cout<<"模式串T在主串S中首次出现的位置是: "<<KMP_Index()<<endl;cout<<KMP_Count()<<endl;}return 0;
}

 

#include <iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
#include<cmath>
using namespace std;
const int MAXN=1000+100;
char S[MAXN],T[MAXN];
int next[MAXN];
int n,m;
int cnt,last;
void getFail()
{next[0]=next[1]=0;for(int i=1;i<m;i++){int j=next[i];while(j && T[i]!=T[j]) j=next[j];next[i+1] = (T[i]==T[j])?j+1:0;}
}
void KMP()
{n=strlen(S);m=strlen(T);getFail();int j=0;for(int i=0;i<n;i++){while(j && S[i]!=T[j]) j=next[j];if(S[i]==T[j]) j++;if(j==m){if(cnt==0){cnt++;last=i;//last指向匹配位置的末尾}else if(i-last>=m){cnt++;last=i;}}}
}
int main()
{while(scanf("%s",S)==1){if(strcmp(S,"#")==0)break;scanf("%s",T);cnt=0;KMP();printf("%d\n",cnt);}return 0;
}

 

这篇关于HDU 2087 剪花布条(KMP 三种做法)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/379390

相关文章

usaco 1.3 Mixing Milk (结构体排序 qsort) and hdu 2020(sort)

到了这题学会了结构体排序 于是回去修改了 1.2 milking cows 的算法~ 结构体排序核心: 1.结构体定义 struct Milk{int price;int milks;}milk[5000]; 2.自定义的比较函数,若返回值为正,qsort 函数判定a>b ;为负,a<b;为0,a==b; int milkcmp(const void *va,c

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2093 考试排名(sscanf)

模拟题。 直接从教程里拉解析。 因为表格里的数据格式不统一。有时候有"()",有时候又没有。而它也不会给我们提示。 这种情况下,就只能它它们统一看作字符串来处理了。现在就请出我们的主角sscanf()! sscanf 语法: #include int sscanf( const char *buffer, const char *format, ... ); 函数sscanf()和

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

hdu 3790 (单源最短路dijkstra)

题意: 每条边都有长度d 和花费p,给你起点s 终点t,要求输出起点到终点的最短距离及其花费,如果最短距离有多条路线,则输出花费最少的。 解析: 考察对dijkstra的理解。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstrin

hdu 2489 (dfs枚举 + prim)

题意: 对于一棵顶点和边都有权值的树,使用下面的等式来计算Ratio 给定一个n 个顶点的完全图及它所有顶点和边的权值,找到一个该图含有m 个顶点的子图,并且让这个子图的Ratio 值在所有m 个顶点的树中最小。 解析: 因为数据量不大,先用dfs枚举搭配出m个子节点,算出点和,然后套个prim算出边和,每次比较大小即可。 dfs没有写好,A的老泪纵横。 错在把index在d

hdu 1102 uva 10397(最小生成树prim)

hdu 1102: 题意: 给一个邻接矩阵,给一些村庄间已经修的路,问最小生成树。 解析: 把已经修的路的权值改为0,套个prim()。 注意prim 最外层循坏为n-1。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstri

hdu 1285(拓扑排序)

题意: 给各个队间的胜负关系,让排名次,名词相同按从小到大排。 解析: 拓扑排序是应用于有向无回路图(Direct Acyclic Graph,简称DAG)上的一种排序方式,对一个有向无回路图进行拓扑排序后,所有的顶点形成一个序列,对所有边(u,v),满足u 在v 的前面。该序列说明了顶点表示的事件或状态发生的整体顺序。比较经典的是在工程活动上,某些工程完成后,另一些工程才能继续,此时